%undefine _py3_shebang_s

%global _docdir_fmt %{name}

%bcond_without bootstrap

%if %{with bootstrap}
%bcond_with tests
%bcond_with doc
%else
%bcond_without tests
%bcond_without doc
%endif

Summary:        Jupyter protocol implementation and client libraries
Name:           python-jupyter-client
Version:        8.6.1
Release:        1%{?dist}
License:        BSD
URL:            https://jupyter.org
Source0:        %{pypi_source jupyter_client}

BuildRequires:  python3-devel
BuildArch:      noarch

%if %{with tests}
BuildRequires:  python3-zmq-tests
BuildRequires:  python3dist(msgpack)
BuildRequires:  /usr/sbin/ip
BuildRequires:  /usr/bin/ifconfig
%endif

%description
This package contains the reference implementation of the Jupyter protocol.
It also provides client and kernel management APIs for working with kernels.

It also provides the `jupyter kernelspec` entrypoint for installing kernelspecs
for use with Jupyter frontends.

%package -n     python3-jupyter-client
Summary:        Jupyter protocol implementation and client libraries
Recommends:     python3-netifaces

%description -n python3-jupyter-client
This package contains the reference implementation of the Jupyter protocol.
It also provides client and kernel management APIs for working with kernels.

It also provides the `jupyter kernelspec` entrypoint for installing kernelspecs
for use with Jupyter frontends.

%if %{with doc}
%package -n python-jupyter-client-doc
Summary:        Documentation of the Jupyter protocol reference implementation

%description -n python-jupyter-client-doc
Documentation of the reference implementation of the Jupyter protocol
%endif

%prep
%autosetup -p1 -n jupyter_client-%{version}
sed -Ei '/"\b(codecov|coverage|mypy|pre-commit|pytest-cov)\b",/d' pyproject.toml


%if %{with doc}
sed -i "s|\(('http://ipython.readthedocs.io/en/stable/', \)None)|\1'/usr/share/doc/python3-ipython-doc/html/objects.inv')|" docs/conf.py
%endif

%generate_buildrequires
%pyproject_buildrequires %{?with_tests:-x test} %{?with_doc:-x docs}


%build
%pyproject_wheel

%if %{with doc}
PYTHONPATH=build/lib/ sphinx-build-3 docs html
rm -r html/.{doctrees,buildinfo}
%endif


%install
%pyproject_install
%pyproject_save_files jupyter_client

%if %{with tests}
%check
%pytest -Wdefault -v -k "not test_signal_kernel_subprocesses and not test_async_signal_kernel_subprocesses and not test_open_tunnel"
%endif

%files -n python3-jupyter-client -f %{pyproject_files}
%doc README.md
%{_bindir}/jupyter-kernel
%{_bindir}/jupyter-kernelspec
%{_bindir}/jupyter-run

%if %{with doc}
%files -n python-jupyter-client-doc
%doc html
%endif

%changelog
* Thu Jun 13 2024 Shuo Wang <abushwang@tencent.com> - 8.6.1-1
- initial build
